# This code is free software; you can redistribute it and/or modify it under
# the terms of the new BSD License.
#
# Copyright (c) 2010, Sebastian Staudt

require 'test_parameter'

class TestFlag < Test::Unit::TestCase

  include TestParameter

  context 'A Rubikon flag' do

    should 'be a Parameter' do
      assert Flag.included_modules.include?(Parameter)
      assert Flag.new(@app, :test).is_a?(Parameter)
    end

    should 'call its code block if it is activated' do
      block_run = false
      flag = Flag.new @app, :flag do
        block_run = true
      end
      flag.send :active!
      assert flag.active?
      assert block_run
    end

    should 'not allow any arguments' do
      flag = Flag.new @app, :test
      assert_raise ExtraArgumentError do
        flag.send(:<<, 'argument')
      end

      assert flag.send(:args_full?)
      assert !flag.send(:more_args?)
      assert !flag.respond_to?(:args)
    end

  end

end
